// ***********************************************
//   DG14032 Demo
//	Erste Variante zum Experimentieren
// ***********************************************
/*
Datenblatt Seite 11:

Display Data RAM (DDRAM)

to display HCGROM Fonts 8 x 16:
- 2 Bytes ins DDRAM schreiben. Jedes Byte reprsentiert ein Zeichen. 0x02...0x7F = 2...127

Ist falsch!!! Naja, nicht ganz. 
Jedes Byte bestimmt, an welcher Adresse ein gewnschtes Zeichen erscheinen soll. Dafr gengt ein einziges Byte zusammen mit "CMD_SET_DDRAM_ADR"!
Danach Daten schreiben: Ein Daten-Byte gibt an, welches alphanumerische Zeichen 0x02..0x7F erscheinen soll.

to display CGRAM Fonts 16 x 16:
- 2 Bytes ins DDRAM schreiben. Es gibt nur 4 Speicherstellen ( = Adressen). 0x0000, 0x0002, 0x0003, 0x0004
	Fr selbstdefinierte Zeichen.
	
to display CGROM Fonts 16 x 16:
- big5 code:	0xA140...0xD75F	= 41280...55135
- GB-code:		0xA1A0...0xF7FF = 41376...63487

write high-Byte first, low-Byte next.


Version6:
Wie bekommt man die Oszillatorfrequenz von 8 MHz auf 4 MHz?

CLKPR CLKPCE    CLKPS3 CLKPS2 CLKPS1 CLKPS0

CLKPS3 CLKPS2 CLKPS1 CLKPS0 Clock division factor
	0 	0 		0 		0 			1
	0 	0 		0 		1			2			<<<<--- DIESEN VERWENDEN

The CLKPCE bit must be written to logic one to enable change of the CLKPS bits. The CLKPCE
bit is only updated when the other bits in CLKPR are simultaneously written to zero.



AVR Memory Usage
----------------
Device: atmega48

Program:    2106 bytes (51.4% Full)
(.text + .data + .bootloader)

Data:          1 bytes (0.2% Full)
(.data + .bss + .noinit)


Build succeeded with 0 Warnings...
_________________________________________
AVR Memory Usage
----------------
Device: atmega48

Program:    2118 bytes (51.7% Full)
(.text + .data + .bootloader)

Data:          1 bytes (0.2% Full)
(.data + .bss + .noinit)


Build succeeded with 0 Warnings...

___________________________________________

AVR Memory Usage
----------------
Device: atmega48

Program:    2008 bytes (49.0% Full)
(.text + .data + .bootloader)

Data:          1 bytes (0.2% Full)
(.data + .bss + .noinit)

Die Verwendung von ltoa anstatt itoa bentiogt 74 Bytes code mehr.#
ltoa: Convert a long integer to a string.

___________________________________________
Version7: 
Es sollen einzelne Befehle ausprobiert werden, Text lschen, Grafikspeicher Lschen, einzelnes Pixel setzen, 
um heraus zu finden, wie man alle Zeichen aus dem ROM auf das Display bringt.
Es erscheinen alle Zeichen des "groen" Codebereiches: 	for ( m=0xA140; m<=0xF800; m++) 

Cursor blinken on/off, reverse-display, character blink on/off, standby mode


Bytes schieben und aus 16-bit-Variable zwei 8-bit-Variablen machen: siehe TDA 1543.c

register uint16_t  zaehler1 asm("r28");			//Variable wird hoch gezhlt und an DA-Wandler ausgegeben, in Register anlegen geht nicht.
register uint16_t  zaehler2 asm("r26");

	zaehler2 = zaehler1 >> 8;	//bringt laut Simulator das obere Byte!!!!


Thema:
	Word-Variable in Byte verwandeln:

	http://www.mikrocontroller.net/topic/19395


	word w;
	byte blow,bhigh;

	bl = w & 0xFF;
	bh = w >> 8;
	
	
	
	
	Re: uint16 zu uint8 und zurck
	Autor: Laszlo H. (laszlo_h)
	Datum: 02.06.2011 18:48

	Simon schrieb:
	> // Von zwei byte auf 1 word
	> word  = 1byte << 8;
	> word |= 2byte

	Als Einzeiler:

	word = (1byte << 8) | 2byte;

	
	Danke, jetzt brauch ich nur noch den Weg wieder zurck
	Also vom Word wieder in zwei bytes aufteilen


	Re: uint16 zu uint8 und zurck
	Autor: DirkB (Gast)
	Datum: 02.06.2011 19:16

	1byte = word >> 8;		// 1 Byte ist das hherwertige Byte		--->>> dieses ins Programm einbauen fr chinesische Zeichen
	2byte = word & 0xff;	// 2 Byte ist das niederwertige			--->>> dieses ins Programm einbauen fr chinesische Zeichen
__________________________
16.1.2014
DG14032-demo24C08_9.c soll zustzlich die Ansteuerung zum I2C-EEPROM 24C08 erhalten und Zeichen aufs DG14032 ausgeben.
Ein Sockel fr den Infrarot-Empfnger ist bereits hinzu gekommen, 
ebenso ein Sockel fr ein 1-Wire-Gert, z.B. den Temperatursensor DS18S20.
Das I2C-EEPROM soll ber das im Mikrocontroller eingebaute TWI angesteuert werden.
Hierzu erster Test mit AT24C.h aus 
E:\10_2013\I2C-EEPROM_fertige_Projekte\I2C-EEPROM_Speicherverwaltung
USB-Stick/I2CEEPROM_fertige_Projekte/Mikrocontroller_net/Portexpander-Beispiel 

folgende Unterprogramme sind neu:
uint8_t AT24WriteByte(uint16_t dataaddress, uint8_t data);
uint8_t AT24ReadByte(uint16_t dataaddress);



RC5-Empfang ber den Infrarot-Empfnger knnte man hinzu fgen, bentgt aber dann mindestens einen Mega88.
Hierfr die Dateien der RC5-Lampe verwenden.
OK. RC5-Empfang geht. Ausgabe aufs GLCD angepat. Eine Position hat die Breite von zwei (!) Ziffern.

Fr Schaltung mit 28-Pin-AVR auf Platte mit drei Mikrocontrollern, DG14032-Sockel, PCF8574, 24C08, SPI-EEPROM.


21.1.2014
Das PCF8574 wird ber Adresse 0x20 erstmals angestuert mit den bereits vorhandenen Programmteilen. TWBR = 0x80 -->> 28 kHz
Bevor die LEDs angeltet waren, war nicht zu erkennen, da etwas empfangen wird oder die Ausgnge sich ndern.
Die LEDs sind ber 330 Ohm gegen GND angeltet und leuchten nur extrem schwach.
Anscheinend begrenzt das IC den Ausgangsstrom vom + auf nur 100A.

diese Zeile in AT24.h in der Initialisierung auskommentiert:
//	TWCR= 0x04; //enable twi	The TWEN bit enables TWI operation and activates the TWI interface.

und alle Zeilen auskommentiert, die das obere Adressbyte verschicken. Das 24C08 erwartet nmlich nur ein einziges Byte als Adresse!
Zwei Adressbytes zu schicken wre falsch.


3.2.2014	DG14032-demo24C08_10.c
PCF8574 soll ein LCD ansteuern. Hierzu wurde eine kleine Adapterplatine mit Anschlukabel geltet.

P0	-->>	D4				hat Dualzahlen-Wert 0
P1	-->>	D5				hat Dualzahlen-Wert 1
P2	-->>	D6				hat Dualzahlen-Wert 2
P3	-->>	D7				hat Dualzahlen-Wert 3
P4	-->>	RW				hat Dualzahlen-Wert 4
P5	-->>	E				hat Dualzahlen-Wert 5
P6	-->>	RS				hat Dualzahlen-Wert 6
P7	-->>	LED gegen +5V	hat Dualzahlen-Wert 7

Man mte nun die Abbildung, die das Kabel durchfhrt, genau so in Software machen, damit das Byte, das das PCF8574 zum bertragen erhlt, das LCD richtig ansteuert. 
Ebenso knnte man ber eine umgekehrte Tabelle vom LCD lesen.


//  LCD DB4-DB7 <-->  PORTA Bit PA0-PA3
#define LCD_DATA_PORT PORTA
#define LCD_DATA_DDR  DDRA
#define LCD_DB        PA0


#define LCD_STEUER_PORT PORTA
#define LCD_STEUER_DDR DDRA
//  LCD RS      <-->  PORTA Bit PA4     (RS: 1=Data, 0=Command)
#define LCD_RS        P6

//RW soll vorerst immer low = schreiben sein. Dieser Zustand mu vor jeder Ausgabe auf das LCD neu hergestellt werden.
//  LCD RW      <-->  PORTA Bit PA5     (RW: 1=lesen, 0=schreiben)
#define LCD_RW        P4
 

#define LCD_ENABLE_PORT PORTC
#define LCD_ENABLE_DDR DDRC 
//  LCD EN      <-->  PORTC Bit PC7     (EN: 1-Impuls fr Daten)
#define LCD_EN        P5


Das angeschlossene LCD reagiert berhaupt nicht. Mit den angeschlossenen LEDs liegt bei high nur 1,8 V an.
Ohne LEDs sind es 5 V, aber das LCD reagiert ebenfalls nicht. Ist die Enable-Flanke verschliffen?
Nein, es geht nun sogar mit den angeschlossenen LEDs, zumindest mit dem 2x8-LCD fr 1 von Pollin.
Es fehlte in "I2CLCD-enable" ein I2C-Aufruf, so da der Enable Impuls nicht kam.

selbst geschriebenes ItoA hinzugefgt in der Version, die auch noch Leerzeichen einfgt bei krzeren Zahlen, damit die Zahl rechtsbndig erschient.
E:\Schau_Ma_26_6_13\ITOA-selbst-gemacht\ItoA-Simulation_2313.zip

AVR Memory Usage
----------------
Device: atmega48

Program:    4078 bytes (99.6% Full)
(.text + .data + .bootloader)

Data:         18 bytes (3.5% Full)
(.data + .bss + .noinit)


Build succeeded with 8 Warnings...

__

6.2.2014	DG14032-demo24C08_11.c
Befreiung von berschssigen Kommentaren und auskommentierten Befehlszeilen

*/






#include <avr/io.h>
#include <avr/pgmspace.h>
#include "graphic.h"
#include "ST7920.h"
#include <util/delay.h>	//hinzu gefgt
#include <stdlib.h>		// wird nur fr die Funktion "iota" bei der LCD-Ausgabe gebraucht.
#include <avr/pgmspace.h>		//zum Eintragen des Textes, der die Programmversion anzeigt in der hex-Datei.
#include "AT24C.h"
#include "rc5.h"		//fr RC5-Empfang
#include <C:\WinAVR-20100110\avr\include\avr\interrupt.h>	//fr RC5-Empfang
#include "PCF8574.h"

#define INTERFACE_8_BIT

// save program memory -> we do not use _delay_us()
// 1 nop per MHz (adapt if needed)
#define DELAY_1US \
	{			\
	asm("nop"); \
	asm("nop"); \
	asm("nop"); \
	asm("nop"); \
	asm("nop"); \
	asm("nop"); \
	asm("nop"); \
	asm("nop"); \
	}


//Entsprechung findet man in ST7920.pdf Datasheet Seite16.
//instruction set 1 (RE = 0: basic instruction)
#define CMD_DISPLAY_CLEAR	0x01
#define CMD_RETURN_HOME		0x02
#define CMD_ENTRY_MODE		0x04
#define CMD_DISPLAY_CONTROL	0x08
#define CMD_CURSOR_CONTROL	0x10
#define CMD_FUNCTION_SET	0x20
#define CMD_SET_CGRAM_ADR	0x40
#define CMD_SET_DDRAM_ADR	0x80

//Entsprechung findet man in ST7920.pdf Datasheet Seite17.
#define CMDE_STANDBY		0x01	//Seite 23 oben
#define CMDE_SCROLL_SEL		0x02	//Seite 23 obere Mitte
#define CMDE_REVERSE_LINE	0x04	//Seite 23 Mitte
#define CMDE_SET_SCROLL_ADR	0x40
#define CMDE_SET_GDRAM_ADR	0x80

#define BIT_ID 				0x02
#define BIT_S 				0x01
#define BIT_D				0x04
#define BIT_C				0x02
#define BIT_B				0x01
#define BIT_SC				0x08
#define BIT_SR				0x01
#define BIT_RL				0x04
#define BIT_DL				0x10
#define BIT_RE				0x04
#define BIT_G				0x02
#define BIT_BUSY			0x80

#define MASK_CGRAM_ADR		0x3F
#define MASK_DDRAM_ADR		0x3F
#define MASK_SCROLL_ADR		0x3F
#define MASK_GDRAM_ADR_HOR	0x0F
#define MASK_GDRAM_ADR_VER	0x3F

#define PORT_BL 	PORTA
#define DDR_BL  	DDRA
#define BIT_BL	  	PA0
//#define BL_PIN_USED

#ifdef INTERFACE_8_BIT
#define PORT_D0 	PORTD
#define PIN_D0  	PIND
#define DDR_D0  	DDRD
#define BIT_D0  	PD0

#define PORT_D1 	PORTD
#define PIN_D1  	PIND
#define DDR_D1  	DDRD
#define BIT_D1  	PD1

#define PORT_D2 	PORTD
#define PIN_D2  	PIND
#define DDR_D2  	DDRD
#define BIT_D2  	PD2

#define PORT_D3 	PORTD
#define PIN_D3  	PIND
#define DDR_D3  	DDRD
#define BIT_D3  	PD3
#endif

#define PORT_D4 	PORTD
#define PIN_D4  	PIND
#define DDR_D4  	DDRD
#define BIT_D4  	PD4

#define PORT_D5 	PORTD
#define PIN_D5  	PIND
#define DDR_D5  	DDRD
#define BIT_D5  	PD5

#define PORT_D6 	PORTD
#define PIN_D6  	PIND
#define DDR_D6  	DDRD
#define BIT_D6  	PD6
	
#define PORT_D7 	PORTD
#define PIN_D7  	PIND
#define DDR_D7  	DDRD
#define BIT_D7  	PD7

#define PORT_E  	PORTB
#define DDR_E   	DDRB
#define BIT_E   	PB1

#define PORT_RW  	PORTB
#define DDR_RW   	DDRB
#define BIT_RW   	PB6

#define PORT_RS 	PORTB
#define DDR_RS  	DDRB
#define BIT_RS  	PB7

#define PORT_RES 	PORTB
#define DDR_RES  	DDRB
#define BIT_RES  	PB5
//#define RESET_PIN_USED

#define RS_DATA		1
#define RS_CMD		0

#define XTAL		4e6			//Achtung, hier aufpassen wegen dem Quarzteiler durch 8 im mega48!!!!!!!!
								//Am besten auf 8e6 stellen und die Fuse CKDIV8 lschen.
								
//#define simulation		//auskommentieren zum normalen Programmlauf

const char str0[] PROGMEM = "DG14032_PCF8574_lesen_ver1.c";

int main (void) {

	char s[15];		//Array fr ITOA	bisher gengte 11, 15 ntzt auch nichts
// 	uint16_t i = 0;	//Zhlvariable
	uint8_t i = 0; //Zhlvariable
//	uint8_t j = 0; //Zhlvariable
	uint8_t k = 0; //Zhlvariable
	uint16_t m = 0; //Zhlvariable
//	uint16_t	n;		//Variable fr RC5-Empfang
	unsigned int	n;		//Variable fr RC5-Empfang
	uint8_t input = 0;	//gelesenes Byte vom PCF8574
	

//wnschenswert wre noch eine Begrenzung auf 2..3..4 Stellen, die man als Parameter direkt einstellen kann, damit die Ausgabe auf dem LCD nicht zu breit wird.
//Es werden immer mindestens 2 Stellen ausgegeben!!! Stellenanzahl darf nur die Werte <2, 3, 4 oder 5 haben.
//Falls die Zahl grer wird als es die vorgegebene Stellenanzahl erlaubt, wird nach rechts erweitert und die Ziffern verschieben sich wieder wie bisher.
//noch neuere Variante, die am Simulator in 2_2014 ausprobiert wurde:
//void ItoA( int z, char* Buffer )				//ohne Vorgabe der Stellanzahl
void ItoA( int z, char* Buffer, uint8_t Stellenanzahl )	//Stellenanzahl bestimmt, wieviele Stellen die Ausgabe haben soll. (Das Minuszeichen entfllt.)
{
uint8_t i = 0;		//Laufvariable fr Buffer
uint8_t j;
  char tmp;
  unsigned u;    // In u bearbeiten wir den Absolutbetrag von z.


void Leerzeichen (void)
	{
	Buffer[0] = ' ';	//Achtung! das stimmt fr negative Zahlen nicht mehr, oben bereits in Buffer[0] das Minus-Zeichen geschrieben wird.
	Buffer++; 	 //immer wenn ein Zeichen fest an den Anfang der Zeichenfolge geschrieben wird, Buffer-Pointer eins weiter stellen!
	}

 
    // ist die Zahl negativ?
    // gleich mal ein - hinterlassen und die Zahl positiv machen
    if( z < 0 ) {
      Buffer[0] = '-';
      Buffer++;			//immer wenn ein Zeichen fest an den Anfang der Zeichenfolge geschrieben wird, Buffer-Pointer eins weiter stellen!
	  /*
	  Erkenntnis aus einer Simulation_chr:
	  char* Buffer habe die Adresse 0x00D2 im SRAM. Buffer++ setzt den char-Pointer auf die nchste Adresse 0x00D3
	  Bis hierher hat Buffer[0] die Adresse 0x00D2 und
					  Buffer[1] die Adresse 0x00D3.
					  
	Nach Buffer++ sind alle Adressen eins weiter!!!!!!!!!!!!!!!
	Also
					  Buffer[0] die Adresse 0x00D3 und
					  Buffer[1] die Adresse 0x00D4.
	  */
	  // -INT_MIN ist idR. grer als INT_MAX und nicht mehr 
      // als int darstellbar! Man muss daher bei der Bildung 
      // des Absolutbetrages aufpassen.
      u = ( (unsigned)-(z+1) ) + 1; 
    }
    else { 
      u = (unsigned)z;
    }

//	if ( u < 10000 ) Leerzeichen ();//Diese Abfrage kann entfallen, falls man nur kleine Zahlen unter 10000 haben sollte.
	if ((u < 10000) & (Stellenanzahl > 4)) Leerzeichen ();//Diese Abfrage kann entfallen, falls man nur kleine Zahlen unter 10000 haben sollte.


//	if ( u < 1000 ) Leerzeichen ();	
	if ((u < 1000) & (Stellenanzahl > 3)) Leerzeichen ();	

	
//	if ( u < 100 ) Leerzeichen ();
	if ((u < 100) & (Stellenanzahl > 2)) Leerzeichen ();
		
	if ( u < 10 ) Leerzeichen ();		
	
    // die einzelnen Stellen der Zahl berechnen
    do {
      Buffer[i++] = '0' + u % 10;
      u /= 10;
    } while( u > 0 );
 
	
	// den String in sich spiegeln
    for( j = 0; j < i / 2; ++j ) {
      tmp = Buffer[j];
      Buffer[j] = Buffer[i-j-1];
      Buffer[i-j-1] = tmp;
    }
    Buffer[i] = '\0';		//Ende-Zeichen anhngen
}



//Takt einstellen:  (bei 8 MHz gibt es immer Bildfehler, AVR-Studio ist immer auf 4 MHz eingestellt)
	CLKPR = 0x80;			//CLKPCE auf 1 setzen und alle anderen Bits auf 0, um die Funktionalitt zu aktivieren
	//CLKPR = 1 << CLKPS2;	//8 MHz / 16 = 500 kHz --->>>	keinerlei Bildfehler mehr
	CLKPR = 1 << CLKPS0;	//8 MHZ / 2 = 4 MHz 	--->>>	keinerlei Bildfehler mehr	<<<---<<<<-- diese verwenden fr 4 MHz
//	CLKPR = 1 << CLKPS1;



//Am PORTB den PB0 = Pin14 als Eingang fr den TSOP IR-Empfnger konfigurieren, ist an PIN14 angeschlossen
//	DDRB = 0x01; falsch		// nur PB0 soll Eingang sein
	PORTB = 0x01;   // PortB , PB0 auf Pullup= ein schalten 
//	TCCR0B = 1<<CS02;			//divide by 256
	TCCR0B = 1<<CS02;			//divide by 256
	TIMSK0 = 1<<TOIE0;			//enable timer interrupt


	initAT24();				//I2C-EEPROM 24C08 initialisieren
#ifndef	simulation
	GLCD_Init();
	GLCD_ClearTXT();		//lscht das ganze Display
	GLCD_ClearGFX();		//lscht nur die Grafik, nicht aber den Text!!!
	GLCD_WriteString(0,0,"RC5-GLCD");
	Delay(300000UL);
#endif


	sei();					//Interrupts frei geben fr RC5-Empfang

	while (1)
	{

//	for ( uint8_t i=0; i<=127; i++) 	{
	for ( uint8_t i=0; i<=7; i++) 		{
//	for ( uint16_t i=0; i<=35000; i++) 	{

//Port-Expander bedienen:
//Adresse des Portexpanders PCF8574: A2, A1, A0 sind auf GND geltet -->> 0100 000 = 0x40
	/*address can be 0 .. 8; rw=0 --> write, rw=1 --> read*/
//	pcf8574_set_outputs (i, j);		//PCF8574: A2, A1, A0 sind auf GND geltet -->> 0100 000X = 0x40 oder ein Bit nach rechts verschoben: 0x20
//	pcf8574_set_outputs (0x20, i);		//PCF8574 hat Adresse 0x20!!!	<<<---<<<--- OK funktioniert 0x20 ist falsch, da UP 0..8 erwartet.!!!!!!!!!!!!!<<<---<<<---
//	pcf8574_set_outputs (0, i);		//PCF8574 hat Adresse 0 !!!	<<<---<<<--- OK funktioniert. 0x20 ist falsch, da UP 0..8 erwartet.!!!!!!!!!!!!!<<<---<<<---
	/*address can be 0 .. 8; rw=0 --> write, rw=1 --> read*/

//	input = pcf8574_get_inputs (0x20);	//PCF8574: A2, A1, A0 sind auf GND geltet -->> 0100 000 = 0x40
//	pcf8574_set_outputs (0, 0xFF);		//Ausgnge sollen vor dem Lesen high sein!	
	input = pcf8574_get_inputs (0);	//PCF8574: A2, A1, A0 sind auf GND geltet -->> 0100 000 = 0x40
	GLCD_WriteString(6,0, itoa( input, s, 10));	//Stelle6, Zeile1, Ausgabe des gelesenen Bytes vom PCF8574
//Ende Port-Expander bedienen

/*Diese Zeile verwenden*/
	GLCD_WriteString(5,0, itoa( AT24ReadByte (i), s, 10));	//Stelle5, Zeile1, Ausgabe des gelesenen Bytes aus dem EEPROM
/*Ende diese Zeile verwenden*/


#ifndef	simulation
//mit den selbstgessschriebenen ItoA:
	ItoA( i, s, 3);
	GLCD_WriteString(0,1, s);	//zeigt die ans TWI geschickte Adresse an, ganz links, Zeile 2
	
//	ItoA( i, s, 3);
//	GLCD_WriteString(2,1, s);	//zeigt, welches Byte das PCF8574 an die Ausgnge legen soll, dritte Stelle, Zeile 2

	_delay_ms( 30);
	//if ( i < 150 ) _delay_ms( 100);
	//if ( i > 150 ) _delay_ms( 1);
	
#endif	
	}				//Ende for
	
	


//RC5-Teil
    cli();
    n = rc5_data;			// read two bytes from interrupt !
    rc5_data = 0;
    sei();
	
    if( n ){
			
			//lcd_data( ( n >> 11 & 1) + '0' );
		//	GLCD_WriteString(0,1, (uint16_t) (( n >> 11 & 1) + '0'));	//hier soll ein Ausdruck vom Typ Integer angezeigt werden. -->> falsch
			GLCD_WriteString(0,1, itoa(( n >> 11 & 1), s, 10));	//hier soll ein Ausdruck vom Typ Integer angezeigt werden. + '0' entfllt

			
		//	GLCD_WriteString(0,1," ");	//Leerzeichen
			
			
			itoa( n >> 6 & 0x1F, s, 10);	// Device address
			GLCD_WriteString(2,1, s );		//an fnfte Stelle schreiben
			
		
		//	GLCD_WriteString(4,0, itoa( 63, s, 10));	//nur zum Test, ob die 63 geschrieben wird. -->> ja!, AN sTELLE 10
	
	  		//itoa((n & 0x3F) | (~n >> 7 & 0x40), s, 10);	// Key Code   s ist ein character-array mit 30 Zeichen
			itoa((n & 0x3F) | (~n >> 6 & 0x40), s, 10);	//Achtung!!! hier die Korrektur anbringen 6 anstatt 7 schreiben
			GLCD_WriteString(4,1, s);	//an neunte Stelle schreiben

			_delay_ms( 300); //Anzeige soll nicht gleich verlschen
			}
//Ende des RC5-TEils

	}	//Ende while

	return 0;
}
